import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { select, axisLeft, axisBottom, csv, arc, pie, scaleBand, scaleLinear, max, format} from 'd3';

const csvUrl =
  'https://gist.githubusercontent.com/yamunayennem/d4304838e08f5970f06be793d3576d97/raw/4a9d01b1086db4031a7fe426df159a8439ca8fbf/covid-deaths'
const width = 960;
const height = 500;
const margin = { top: 10, right: 10, bottom: 50, left: 100 };

const App = () => {
  
  const [data, setData] = useState(null);

  useEffect(() => {
    const row = d => {
      if(d['total deaths']!==null){
      d.total_deaths =d['\ttotal deaths'];

      }
      console.log("popultion**",d)

      return d;
    };
    
    csv(csvUrl, row).then(data => {

     setData(data.slice(0, 3));
    });
  }, []);

  if (!data) {
    return <pre>No Data...</pre>;
  }

  const innerHeight = height - margin.top - margin.bottom - 50;
  const innerWidth = width - margin.left - margin.right;

  const yScale = scaleBand()
    .domain(data.map(d => d.Country))
    .range([0, innerHeight]);
		data.map(d=>{
      console.log(d)
    })
  const xScale = scaleLinear()
  
    .domain([0, max(data, d =>d.total_deaths)])
    .range([0, innerWidth]);

  return (
    <svg width={width} height={height}>
      <g transform={`translate(${margin.left},${margin.top})`}>
        {xScale.ticks().map(tickValue => (
          <g key={tickValue} transform={`translate(${xScale(tickValue)},0)`}>
            <line y2={innerHeight} stroke="purple" />
            <text
              style={{ textAnchor: 'middle' }}
              dy=".70em"
              y={innerHeight + 2}
            >
              {tickValue}
            </text>
          </g>
        ))}
        {yScale.domain().map(tickValue => (
          <>
          <p>"tickValue"</p>
          <text
            key={tickValue}
            style={{ textAnchor: 'end' }}
            x={-5}
            dy=".22em"
            y={yScale(tickValue) + yScale.bandwidth() / 2}
          >
            {tickValue}
          </text>
            </>
        ))}
        {data.map(d => (
          <rect
            key={d.country}
            x={0}
            y={yScale(d.country)}
            width={xScale(d.total_deaths)}
            height={yScale.bandwidth()}
          />
        ))}
      </g>
    </svg>
  );
};
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);